/*****************************************************************************
 *	aisa29s.c
 * 
 *	aISA-M29 
 *	
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.	
 *	 
 *	Date 1998/05/20
 *
 *	̃\[Xɂ̓bp[֐̎gpႪLqĂ܂B
 *	 
 *****************************************************************************/
#define	STRICT
#include <windows.h>
#include <tchar.h>
#include "aisa29w.h"

const TCHAR szTitle[]	= _T("Sample");
const TCHAR szM29[]		= _T("aISA-M29");

static void ResultMessage(LPCTSTR lpszbuf);
static void ErrorMessage(WORD wLogSlot);

int WINAPI WinMain(
	HINSTANCE hInstance,
	HINSTANCE hPrevInstance,
	LPSTR lpCmdLine,
	int nCmdShow)
{
	TCHAR	szBuf[256];				// ʕ\p
	BOOL	bResult;				// `oh̖߂l
	DWORD	dwDllVer, dwDrvVer;		// o[W
	WORD	wLogSlot;				// _Xbgԍ
	AISA29RESOURCE	ri;				// \[X\
	BYTE	bMode;					// [h
	BYTE	bStatus;				// Xe[^X
	DWORD	dwCountData;			// JE^f[^
	DWORD	dwCH1Data;				// JXP[hpf[^P
	DWORD	dwCH2Data;				// JXP[hpf[^Q

	//-------------------------------------------------------------------------
	// aisa29.dll J
	//-------------------------------------------------------------------------
	if ( Aisa29wDllOpen() == FALSE ){
		ErrorMessage(AISA29_SLOT_AUTO);
		return 1;
	}
	//-------------------------------------------------------------------------
	// o[W\
	//-------------------------------------------------------------------------
	if (Aisa29wGetVersion(&dwDllVer, &dwDrvVer) == FALSE)
	{
		ErrorMessage(AISA29_SLOT_AUTO);
		return 1;
	}
	wsprintf(szBuf, _T("GetVersion\n")
					_T("DLL Version: %08lxh\n")
					_T("DRV Version: %08lxh"),
					dwDllVer,
					dwDrvVer);
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// aISA-M29 ̎gp錾
	//-------------------------------------------------------------------------
	wLogSlot = AISA29_SLOT_AUTO;		// gp̃foCXT܂B
	bResult = Aisa29wCreate(&wLogSlot);	// ꍇA̎̃foCXi[܂B

	if (bResult == FALSE)				// foCX܂B
	{
		ErrorMessage(AISA29_SLOT_AUTO);
		return 1;
	}

	wsprintf(szBuf, _T("aISA-M29 Created\n\n")
					_T("LogSlot: %2d"),
					 wLogSlot);
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// \[X擾
	//-------------------------------------------------------------------------
	if (Aisa29wGetResource(wLogSlot, &ri) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szBuf, _T("Board Name: %s\n")
					_T("NumPorts: %2d\n")
					_T("IO Address: %04xh-%04xh\n"),
					szM29,
					ri.dwIOPortLength[0],
					ri.dwIOPortBase[0], ri.dwIOPortBase[0] + ri.dwIOPortLength[0] - 1);
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// [hݒ
	//-------------------------------------------------------------------------
	bMode = 0;
	bMode = bMode
			| AISA29_CH1_CH2_COMPARATE_MODE
			| AISA29_CH2_COMPARATE_MODE
			| AISA29_CH1_COMPARATE_MODE;
	// CH2 CLEAR MODE = ONE TIME CLEAR MODE
	// CH1 CLEAR MODE = ONE TIME CLEAR MODE
	// CH1:CH2 COMPARETE MODE = 24bit 2i␔r
	// CH2 COMPARETE MODE = 24(48)bit 2i␔r
	// CH1 COMPARATE MODE = 24bit 2i␔r

	if (Aisa29wModeSet(wLogSlot, bMode) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szBuf,	_T("ModeBit: %xH\n"), bMode);
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// C-REQ o
	//-------------------------------------------------------------------------
	// C-REQ1
	if (Aisa29wCreqWrite(wLogSlot, AISA29_CREQ_1) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}
	// C-REQ2
	if (Aisa29wCreqWrite(wLogSlot, AISA29_CREQ_2) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}

	wsprintf(szBuf,	_T("C-REQ ɏo܂\n"));
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// JE^[ CH1 ɃR}ho
	//-------------------------------------------------------------------------

	// QM͂P{JEg[h
	if ( Aisa29wDataWrite(wLogSlot,AISA29_CH1_2_PHASE_X1_MODE_SET,AISA29_COMMAND_SET_DATA) == FALSE )
	{
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf,	_T("CH1 QM͂P{JEg[h\n"));
	ResultMessage(szBuf);

	// JE^[Cl[u
	if ( Aisa29wDataWrite(wLogSlot,AISA29_CH1_COUNT_ENABLE_SET,AISA29_COMMAND_SET_DATA) == FALSE )
	{
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf,	_T("CH1 JE^[Cl[u\n"));
	ResultMessage(szBuf);

	//-------------------------------------------------------------------------
	// JE^[ CH1 Ƀf[^o
	//-------------------------------------------------------------------------
	dwCountData = 0;
	// 0 Zbg
	if (Aisa29wDataWrite(wLogSlot,AISA29_CH1_COUNTER_WRITE, dwCountData) == FALSE )
	{
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf,	_T("CH1 CounterWrite\n\n") _T("0 Zbg܂\n"));
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// Xe[^Xǂݍ
	//-------------------------------------------------------------------------
	if (Aisa29wGetStatus(wLogSlot,&bStatus) == FALSE )
	{
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf,	_T("Status: %xH\n"),bStatus );
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// JE^[ CH1 f[^ǂݍ
	//-------------------------------------------------------------------------
	if (Aisa29wDataRead(wLogSlot,AISA29_CH1_COUNTER_READ, &dwCountData) == FALSE )
	{
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf,	_T("CH1 CounterRead\n\n%08xH\n"), dwCountData );
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// JXP[ho
	//-------------------------------------------------------------------------
	dwCH1Data = 0x0;
	dwCH2Data = 0x0;

	if (Aisa29wCascadeWrite(wLogSlot, dwCH1Data, dwCH2Data ) == FALSE )
	{
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf,	_T("CascadeWrite\n\n") _T("0 Zbg܂\n"));
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// JXP[hǂݍ
	//-------------------------------------------------------------------------
	if (Aisa29wCascadeRead(wLogSlot, &dwCH1Data, &dwCH2Data ) == FALSE )
	{
		ErrorMessage(wLogSlot);
		return 1;
	}
	wsprintf(szBuf,	_T("CascadeRead\n\n")
					_T("CH1 :%08xH\n")
					_T("CH2 :%08xH\n"),
					dwCH1Data,dwCH2Data );
	ResultMessage(szBuf);
	//-------------------------------------------------------------------------
	// aISA-P31̎gpJ
	//-------------------------------------------------------------------------
	if (Aisa29wClose(wLogSlot) == FALSE)
	{
		ErrorMessage(wLogSlot);
		return 1;
	}
	ResultMessage(_T("aISA-M29 Closed"));
	//-------------------------------------------------------------------------
	// aisa29.dll ̎gpJ
	//-------------------------------------------------------------------------
	if (Aisa29wDllClose() == FALSE)
	{
		MessageBox(NULL, _T("DLL ̃A[hɎs܂B"), szTitle, MB_OK | MB_ICONSTOP);
		return 1;	// aisa29.dll ̃A[hɎs܂B
	}

	return 0;
}

//-----------------------------------------------------------------------------
// ʂ\
//-----------------------------------------------------------------------------
static void ResultMessage(LPCTSTR lpszbuf)
{
	MessageBox(NULL, lpszbuf, szTitle, MB_OK | MB_ICONINFORMATION);
}

//-----------------------------------------------------------------------------
// G[bZ[W\
//-----------------------------------------------------------------------------
static void ErrorMessage(WORD wLogSlot)
{
	DWORD dwRes = Aisa29wGetLastError(wLogSlot);
	TCHAR szbuf[128];

	switch (dwRes)
	{
		case AISA29_ERR_SYSTEM:
			wsprintf(szbuf, _T("System error\n\n")
							_T("Error code: %08lxh"),
							GetLastError());
			break;

		case AISA29_ERR_WRAPDLL:
			wsprintf(szbuf, _T("DLL Load error"));
			break;

		default:
			wsprintf(szbuf, _T("aISA-M29 error\n\n")
							_T("Error code: %08lxh"),
							dwRes);
			break;
	}
	MessageBox(NULL, szbuf, szTitle, MB_OK | MB_ICONSTOP);
}
